#include "lines.h"


Lines::Lines(QWidget *parent, Qt::WFlags flags)
	: QMainWindow(parent, flags)
{
	ui.setupUi(this);
	
	QImage neutralImage("picture.jpg");
	QPixmap neutralPicture = QPixmap::fromImage(neutralImage);
	ui.label->setPixmap(neutralPicture);
	
	board = new linesBoard(this);
	board->setFixedSize(277, 277);
	ui.gridLayout1->addWidget(board);//, 0, 1, 6, 1);
	
	
	connect ( board,
		SIGNAL(scoreChanged(int)),
		this,
		SLOT (editScore(int)));
	connect ( board,
		SIGNAL(newBoardSize(int)),
		this,
		SLOT (editResizeBoardWidget(int)));
	connect ( board,
		SIGNAL(endGame(int)),
		this,
		SLOT (checkTopScore(int)));
	connect ( ui.actionNewGame,
		SIGNAL(triggered()),
		this,
		SLOT (newGameStart() )  );
	connect ( ui.actionExit,
		SIGNAL(triggered()),
		this,
		SLOT ( close() )  );
	connect (ui.newGameBtm,
		SIGNAL(clicked()),
		this,
		SLOT( newGameStart() ) );
	connect ( ui.actionTop,
		SIGNAL(triggered()),
		this,
		SLOT ( showTop() )  );
	connect ( ui.actionAbout,
		SIGNAL(triggered()),
		this,
		SLOT ( aboutMe() )  );
	connect ( ui.actionHelp,
		SIGNAL(triggered()),
		this,
		SLOT ( helpGame() )  );
	QFile fileTop(FILE_NAME);
	if (! fileTop.open(QIODevice::ReadOnly) )
	{
		if ( fileTop.open(QIODevice::WriteOnly) )
		{
			 fileTop.close();
		}
	}
	
	

}

Lines::~Lines()
{

}




void Lines::newGameStart()
{
	board->newGameClicked();
}

void Lines::editScore(int newScore)
{
	ui.scoreLabel->setText(QString::number(newScore) );
	
}

void Lines::editResizeBoardWidget(int newSizePixels)
{
	board->setFixedSize(newSizePixels, newSizePixels);
}

void Lines::checkTopScore(int lastScore)
{
	QFile fileTop(FILE_NAME);
	if (fileTop.open(QIODevice::ReadWrite) )
	{
		QList<QPair<QString,int> > topMap;
		QDataStream in(&fileTop);
		in >> topMap;
		
		QList<QPair<QString,int> >::iterator i = topMap.begin();
		int min = 100000;
		while (i != topMap.end())
		{
			if ((*i).second < min)
			{
				min = (*i).second;
			}
			i++;
		}
		if ( (min < lastScore) || (topMap.size() < 10) )
		{
			 QString name = QInputDialog::getText(this, tr("! !  !"),
                                          tr(" :"), QLineEdit::Normal);
             if (topMap.size() >= 10)
             {
				i = topMap.begin();
             	while ( (*i).second != min )
             	{
             		i++;
             	}
             	i = topMap.erase(i);
             }
             topMap.append(QPair<QString, int>(name,lastScore) );
		}
		fileTop.close();
		fileTop.open(QIODevice::WriteOnly);
		QDataStream out(&fileTop);
		out << topMap;
		fileTop.close();
		showTop();
	}
}

void Lines::showTop()
{
	QFile fileTop(FILE_NAME);
	if (fileTop.open(QIODevice::ReadOnly) )
	{
		QList< QPair<QString,int> > topMap;
		QDataStream in(&fileTop);
		in >> topMap;
		QString topString;
		QList< QPair<QString,int> >::iterator j = topMap.begin();
		while (j != topMap.end())
		{
			topString.append((*j).first);
			topString.append(" ");
			topString.append(QString::number((*j).second) );
			topString.append(QChar(10) );
			topString.append(QChar(13) );
			j++;
		}
		fileTop.close();
		QMessageBox::information ( this, "TOP", topString);
	}
}

void Lines::aboutMe()
{
	QString aboutString(tr("<h2>Summer Lines 0.1b</h2><p>:   (-264).<p>e-mail:  <a href=\"mailto:carbonbi4@mail.ru\" class=\"footer\">carbonbi4@mail.ru</a>") );
	QMessageBox::information ( this, tr(" "), aboutString);
}

void Lines::helpGame()
{
	QString helpString(tr("\
   :      9?9 ,           .\ 
<p>       ,       . \
<p>   ,           .\ 
<p>       ,              ( ,   ).\ 
<p>,    ,   .\
<p> ,    .\
\
<p>  Summer Lines  :\
<p>   6?6 .\
<p> ,       4   .\
<p>             1   .") );
	QMessageBox::information ( this, tr(""), helpString);
}
