#ifndef LINESBOARD_H
#define LINESBOARD_H
#define CELL_SIZE 46

#include <QLabel>
//
#include <QImage>
#include <QPainter>
#include <QPixmap>
#include <QMouseEvent>
#include <QRect>
#include <QColor>
#include "mathboard.h"
#include <QStringList>
#include <QTimer>
#include <QQueue>

class linesBoard : public QLabel
{
	Q_OBJECT

public:
	linesBoard(QWidget *parent);
	~linesBoard();
	void newGameClicked();

signals:
	void scoreChanged (int newScore);
	void newBoardSize(int newSizePixels);
	void endGame(int);

private slots:
	void doStep();
	void setBallAfterPause();
	void delBallAfterPause();	
private:
	void setBall(QColor ballColor, int xCell, int yCell);    
	void virtual mousePressEvent ( QMouseEvent * mouseCondition );  
	void deleteBall(int xCell, int yCell); 
	void resize (int newSize);
	void continueGame(int xCell, int yCell);
	
	QPixmap *backgroundPixmap;
	MathBoard mathLinesBoard;	
	QQueue<QString> path;
	QQueue<QString> queueForPauseSet;
	QQueue<QString> queueForPauseDel;
//	int col;
	bool boardIsCreated;
	QTimer *timer;
	QTimer *randomTimer;
	QTimer *randomDelTimer;
};

#endif // LINESBOARD_H
