#ifndef MATHBOARD_H
#define MATHBOARD_H

#define BEGIN_SIZE 6
#define END_SIZE 9
#define MOVE 1
#define NO_MOVE 0
#define DELETE_LENGTH 4
#define NEW_GAME_CODE -100

#include <QObject>
#include <stdlib.h>
#include <QTime>
#include <QColor>
#include <cmath>
#include <QStack>
#include <QPair>
#include <QList>

class MathBoard : public QObject
{
	Q_OBJECT

public:
	MathBoard(QObject *parent);
	MathBoard();
	~MathBoard();
	int getScore();
	QString run(int xCell, int yCell);
	
private:
	int move(int xCell, int yCell, int *xDelCell, int *yDelCell);
	void setMathBall(int color, int xCell, int yCell);
	bool deleteNecessary();   
	int getCurSize ();
	bool isCellForDelete(int i, int j);
	void addScore(int addPoints);
	bool moveEnabled (int xCell, int yCell, int curX, int curY, int waveNumber);
	bool deleteLineSearch(int iFirstCell,int jFirstCell);
	void prepareLineDelete(int iFirstCell, int jFirstCell, int iLast, int jLast, int direction);
	void prepareCellDelete(int i, int j);
	void commandDeleteGraphicBall (int xCellDelete, int yCellDelete, QString &commandString);
	void commandSetGraphicBall (int xCellAdd, int yCellAdd, QString &commandString);
	void commandSetGraphicScore(QString &commandString);
	QStack<int> findPath(int beginX, int beginY, int endX, int endY);
	bool isNextCoordsNearer(int curX, int curY, int nextX, int nextY);
	void commandGraphicMoving (QStack<int> path, QString curColor, QString &commandString);
	void commandGraphicResize(QString &commandString);
	void commandGameGraphicEnd(QString &commandString);
	void commandGameGraphicBegin(QString &commandString);
	bool setRandomBall(int *xRandom, int *yRandom);
	QString color(int xCell, int yCell);
	
	int	boardArr[END_SIZE][END_SIZE];
	int copyArr[END_SIZE][END_SIZE];
	int prevX, prevY;
	int curSize;
	int freeCells;
	int score;
	QList  <QPair <int,int> > freeCellsList;
};

#endif // MATHBOARD_H
